# -*- coding: utf-8 -*-
from Components.ActionMap import *
from Components.ServiceEventTracker import ServiceEventTracker
from Components.Button import Button
from Components.Label import Label
from Components.ConfigList import ConfigListScreen
from Components.Sources.StaticText import StaticText
from Components.ActionMap import NumberActionMap, ActionMap
from Components.config import config, ConfigSelection, getConfigListEntry, ConfigText, ConfigInteger, ConfigDirectory, ConfigYesNo, ConfigSelection, ConfigSubsection, ConfigPIN, configfile
from Components.FileList import FileList, FileEntryComponent
from Components.GUIComponent import GUIComponent
from Components.MenuList import MenuList
from Components.Pixmap import Pixmap, MovingPixmap
from Components.PluginList import PluginEntryComponent, PluginList
from Components.AVSwitch import AVSwitch
from Components.MultiContent import MultiContentEntryText, MultiContentEntryPixmap, MultiContentEntryPixmapAlphaTest
from Components.ServiceEventTracker import ServiceEventTracker

from Plugins.Plugin import PluginDescriptor
from Screens.InfoBar import MoviePlayer
from Screens.HelpMenu import HelpableScreen
from Screens.MessageBox import MessageBox
from Screens.Screen import Screen
from enigma import iPlayableService, iServiceInformation, eServiceReference, eTimer
from enigma import gFont, eTimer, eConsoleAppContainer, ePicLoad, loadPNG, getDesktop, eListboxPythonMultiContent, eListbox, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER, RT_VALIGN_CENTER
from Tools.Directories import pathExists, fileExists, SCOPE_SKIN_IMAGE, resolveFilename
from Tools.LoadPixmap import LoadPixmap
from Tools import Notifications
from Tools.BoundFunction import boundFunction

import urllib, urllib2, re, os, shutil, time, subprocess, datetime, glob
from Tools.Downloader import downloadWithProgress

from twisted.web.client import downloadPage, getPage, error
from twisted.internet import reactor, defer

already_open = False
MoviePlayer.originalOpenEventView = MoviePlayer.openEventView

config.plugins.mediainfo = ConfigSubsection()
config.plugins.mediainfo.donemsg = ConfigYesNo(default = True)
config.plugins.mediainfo.dllimit = ConfigInteger(default = 2, limits = (1,8))
config.plugins.mediainfo.premiumize = ConfigYesNo(default = False)
config.plugins.mediainfo.premiumize_user = ConfigText(default = "User",  fixed_size=False)
config.plugins.mediainfo.premiumize_pass = ConfigText(default = "Pass",  fixed_size=False)
config.plugins.mediainfo.savetopath = ConfigText(default = "/media/hdd/movie/",  fixed_size=False)
config.plugins.mediainfo.delunpack = ConfigYesNo(default = True)
config.plugins.mediainfo.buffersize = ConfigSelection(default = "1", choices = [("1",(1)),("2",(2)),("4",(4)),("8",(8)),("12",(12)),("16",(16)),("32",(32))])

class chooseMenuList(MenuList):
	def __init__(self, list):
		MenuList.__init__(self, list, True, eListboxPythonMultiContent)
		self.l.setFont(0, gFont("Regular", 20))
		self.l.setItemHeight(40)

global joblist
joblist = []

global runslist
runslist = []

global pstatus
pstatus = False

class dlm:
	def __init__(self, session, filename, url):
		self.filename = filename
		self.session = session
		self.url = url
		self.totalMB = 0
		self.end = 100
		self.limit = config.plugins.mediainfo.dllimit.value
		self.runslist = []
		self.pwtrys = 0
		#self.path = "/media/hdd/movie/"
		self.path = config.plugins.mediainfo.savetopath.value
		self.downloadsfile = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/downloads"
		self.storepath = "%s%s" % (self.path, self.filename)
		
	def run(self, checkname):
		self.checkname = checkname
		print "[Download] startet: %s" % checkname
		self.totalMB = 0
		self.download = downloadWithProgress(self.url,self.storepath)
		self.download.addProgress(self.http_progress)
		self.download.start().addCallback(self.http_finished, self.checkname).addErrback(self.http_failed)
		
	def check(self, checkname):
		print "[Download] restart: %s" % checkname
		self.totalMB = 0
		self.checkname = checkname
		checkfilename = (checkname)
		if not checkfilename in runslist:
			print "[Download] file added to runlist: %s" % checkname
			runslist.append((checkname))
		self.downloadLink(self.url, self.storepath, self.checkname, 2)

	def add(self, checkname):
		self.checkname = checkname
		self.totalMB = 0
		print "[Download] startet: %s" % checkname

		global runslist
		print "runlist", len(runslist), config.plugins.mediainfo.dllimit.value
		if len(runslist) <= config.plugins.mediainfo.dllimit.value-1:
			print "[Download] file added to runlist: %s" % self.checkname
			runslist.append((self.checkname))
			print "[Download] max simulation FREE"
			self.downloadLink(self.url, self.storepath, self.checkname, 1)
		else:
			print "[Download] max simulation FULL"
			#site = urllib.urlopen(self.url)
			#meta = site.info()
			#totalBytes = int(meta.getheaders("Content-Length")[0])
			#totalMB = int((totalBytes/1024/1024))
			if fileExists(self.downloadsfile):
				dlfile = open(self.downloadsfile, "a")
				dlfile.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (self.filename, self.storepath, self.url, 999, "Wait", int(time.time())))
				dlfile.close()
			else:
				dlfile = open(self.downloadsfile, "w")
				dlfile.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (self.filename, self.storepath, self.url, 999, "Wait", int(time.time())))
				dlfile.close()
		
	def downloadLink(self, url2, storepath2, checkname2, which):
		api_url = "https://api.premiumize.me/pm-api/v1.php?method=directdownloadlink&params[login]=%s&params[pass]=%s&params[link]=%s" % (config.plugins.mediainfo.premiumize_user.value, config.plugins.mediainfo.premiumize_pass.value, url2)
		getPage(api_url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.get_url_data, storepath2, checkname2, which, url2).addErrback(self.dataError)
		
	def get_url_data(self, data, storepath2, checkname2, which, url):
		print data
		if re.search('(Hoster could not be parsed from link|login failed)', data, re.S):
		#status = re.findall('"status":(.*?),"statusmessage":"(.*?)"', data)
		#if status:
		#	pass
			print "[Download] resume.."
			self.download = downloadWithProgress(url, storepath2)
			self.download.addProgress(self.http_progress2)
			self.download.start().addCallback(self.http_finished, checkname2).addErrback(self.http_failed)
		else:
			print "[Download] resume with premiumize.."
			location = re.findall('"location":"(.*?)"', data)
			if location:
				self.download = downloadWithProgress(location[0].replace('\\',''), storepath2)
				if which == 1:
					self.download.addProgress(self.http_progress)
				else:
					self.download.addProgress(self.http_progress2)
				self.download.start().addCallback(self.http_finished, checkname2).addErrback(self.http_failed)
	
	def stop(self, name):
		print "[Download] gestoppt: %s" % name
		global runslist
		print runslist
		checkfilename = (name)
		if checkfilename in runslist:
			runslist.remove((name))
			print "[Download] file removed from runslist: %s" % name

		self.download.stop()
		dlfile = open(self.downloadsfile, "r")
		dlfile_tmp = open(self.downloadsfile+".tmp", "w")
		for rawData in dlfile.readlines():
			data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
			if data:
				(filename, storepath, url, totalMB, status, starttime) = data[0]
				if filename == name:
					dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, totalMB, "Wait", starttime))
				else:
					dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, totalMB, status, starttime))
		dlfile_tmp.close()
		dlfile.close()
		shutil.move(self.downloadsfile+".tmp", self.downloadsfile)
		print "[Download] move:", self.downloadsfile+".tmp", self.downloadsfile
		
	def http_progress(self, receivedBytes, totalBytes):
		if self.totalMB == 0:
			self.receivedMb = int(float(receivedBytes/1024/1024))
			self.totalMB = int((totalBytes/1024/1024))
			print "[Download] start:", self.receivedMb, "von", self.totalMB
			
			if fileExists(self.downloadsfile):
				dlfile = open(self.downloadsfile, "a")
				dlfile.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (self.filename, self.storepath, self.url, self.totalMB, "Download", int(time.time())))
				dlfile.close()
			else:
				dlfile = open(self.downloadsfile, "w")
				dlfile.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (self.filename, self.storepath, self.url, self.totalMB, "Download", int(time.time())))
				dlfile.close()
				
	def http_progress2(self, receivedBytes, totalBytes):
		if self.totalMB == 0:
			self.receivedMb = int(float(receivedBytes/1024/1024))
			self.totalMB = int((totalBytes/1024/1024))
			print "[Download] start: %s %s von %s" % (self.checkname, self.receivedMb, self.totalMB)
			
			if fileExists(self.downloadsfile):
				dlfile = open(self.downloadsfile, "r")
				dlfile_tmp = open(self.downloadsfile+".tmp", "w")
				for rawData in dlfile.readlines():
					data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
					if data:
						(filename, storepath, url, ttotalMB, status, starttime) = data[0]
						if filename == self.checkname:
							print "[Download] move status:", self.checkname, status, " -> Download"
							dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, self.totalMB, "Download", int(time.time())))
						else:
							dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, ttotalMB, status, starttime))
				dlfile_tmp.close()
				dlfile.close()
				shutil.move(self.downloadsfile+".tmp", self.downloadsfile)
				print "[Download] move:", self.downloadsfile+".tmp", self.downloadsfile
			
	def http_finished(self, string, acheckname):
		print "[Download] done:", acheckname
		global runslist
		checkfilename = ((acheckname))
		if checkfilename in runslist:
			runslist.remove((acheckname))
			print "[Download] file removed from runslist: %s" % acheckname

		if config.plugins.mediainfo.donemsg.value:
			#Notifications.AddNotification(MessageBox, _("%s is Done.") %(self.checkname), type=MessageBox.TYPE_INFO, timeout=3)
			message = self.session.open(MessageBox, _("Mediainfo: %s is Done." % self.checkname), MessageBox.TYPE_INFO, timeout=3)
			
		dlfile = open(self.downloadsfile, "r")
		dlfile_tmp = open(self.downloadsfile+".tmp", "w")
		for rawData in dlfile.readlines():
			data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
			if data:
				(filename, storepath, url, totalMB, status, starttime) = data[0]
				if filename == acheckname:
					#print filename, acheckname
					#print "replace it..."
					dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, totalMB, "Done", starttime))
				else:
					dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, totalMB, status, starttime))
		dlfile_tmp.close()
		dlfile.close()
		shutil.move(self.downloadsfile+".tmp", self.downloadsfile)
		print "[Download] move:", self.downloadsfile+".tmp", self.downloadsfile

		print "[Download] checking for next file.."
		dlfile = open(self.downloadsfile, "r")
		for rawData in dlfile.readlines():
			data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
			if data:
				(filename, storepath2, url2, totalMB, status2, starttime) = data[0]
				if re.match('.*?.part(\S+).rar', acheckname, re.I):
					rarname =  re.compile(".part", re.IGNORECASE).split(acheckname)
					print "[Download] splitting rarname", rarname
					if re.match('.*?'+rarname[0].replace('+',''), filename.replace('+','')):
						print "Status:", status2
						if status2 == "Wait":
							print len(runslist), config.plugins.mediainfo.dllimit.value, status2
							if len(runslist) <= config.plugins.mediainfo.dllimit.value-1:
								runslist.append((filename))
								self.totalMB = 0
								self.checkname = filename
								global joblist
								for (name,job) in joblist:
									if name == self.checkname:
										job.check(self.checkname)
							else:
								print "[Download] status FULL", filename
						else:
							print "[Download] status: No Wait", filename
					else:
						print "[Download] Try.. start next download"
						if status2 == "Wait":
							print len(runslist), config.plugins.mediainfo.dllimit.value, status2
							if len(runslist) <= config.plugins.mediainfo.dllimit.value-1:
								runslist.append((filename))
								self.totalMB = 0
								self.checkname = filename
								global joblist
								for (name,job) in joblist:
									if name == self.checkname:
										job.check(self.checkname)
							else:
								print "[Download] status FULL", filename
						else:
							print "[Download] status: No Wait", filename
		dlfile.close()
		
		print "[Download] checking rarfile.."
		if re.match('.*?.rar', acheckname):
			print "[Download] yes rar file"
			self.check_rar(acheckname, "serienjunkies.org")

	def check_rar(self, rarfile, rarpw):
		if re.match('.*?.part(\S+).rar', rarfile, re.I):
			rarname =  re.compile(".part", re.IGNORECASE).split(rarfile)
			print "[Download] splitting rarname", rarname
			dlfile = open(self.downloadsfile, "r")
			downloads_list = "downloads_list"+rarfile
			downloads_list = []
			for rawData in dlfile.readlines():
				data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
				if data:
					(filename, storepath, url, totalMB, status, starttime) = data[0]
					if re.match('.*?'+rarname[0].replace('+',''), filename.replace('+','')):
						downloads_list.append((filename, status))
			dlfile.close()

			print "[Download] rars found:", downloads_list
			
			count_rars = len(downloads_list)
			counting_rars = 0
			downloads_list.sort()
			
			if count_rars > 1:
				rarunpackfile = downloads_list[1][0]
			else:
				rarunpackfile = downloads_list[0][0]
			
			print "[Download] counting rar files: %s" % count_rars
			for (dl_rarfilename,dl_status) in downloads_list:
				#print dl_rarfilename, dl_status
				if dl_status == "Done" or dl_status == "Stop":
					counting_rars += 1

			if counting_rars == count_rars:
				print "[Download] all RAR downloads done. entpacke.."
				self.container = eConsoleAppContainer()
				cmd = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unrar lt -p%s /media/hdd/movie/%s" % (rarpw, downloads_list[-1][0])
				print cmd
				p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
				line = p.stdout.read()
					
				if re.match('.*?Corrupt file or wrong password.', line, re.S):
					print "[Download] wrong pw..!!!!!!!!!!!"
					message = self.session.open(MessageBox, _("Mediainfo: Falsches Passwort"), MessageBox.TYPE_INFO, timeout=3)
					pwslist = ['Uploadix']
					setpw = pwslist[self.pwtrys]
					if self.pwtrys < len(pwslist):
						print "[Download] try next pw: %s/%s" % (str(self.pwtrys), str(len(pwslist)))
						print "[Download] use pw: %s" % pwslist[self.pwtrys]
						self.pwtrys += 1
						self.check_rar(rarfile, setpw)
				#elif re.match('.*?Name:\s([a-zA-z0-9_-].*\.avi|[a-zA-z0-9_-].*\.mkv|[a-zA-z0-9_-].*\.flv|[a-zA-z0-9_-].*\.mp4).*?Size:\s(\d+)', info, re.S):
				else:
					info = re.findall('Name:\s([a-zA-z0-9_-].*\.avi|[a-zA-z0-9_-].*\.mkv|[a-zA-z0-9_-].*\.flv|[a-zA-z0-9_-].*\.mp4).*?Size:\s(\d+)', line, re.S|re.I)
					print info
					if info:
						unpacked_name = info[0][0].split('/')
						size = int(info[0][1]) / 1024 / 1024
						print "[Download]", unpacked_name[-1], size
						self.container.appClosed.append(boundFunction(self.extractDone,unpacked_name[-1],rarname[0]))
						self.container.dataAvail.append(self.testlog)	
						cmd = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unrar e -p%s /media/hdd/movie/%s -o+ /media/hdd/movie/" % (rarpw, downloads_list[0][0])
						print "[Download] unrar cmd: %s" % cmd
						self.container.execute(cmd)
						self.addunpack(rarunpackfile)
						self.removeRars(rarname[0])	
					else:
						print "[Download] dual packed..!!!!!!!!!!!"
						message = self.session.open(MessageBox, _("Mediainfo: dual packed."), MessageBox.TYPE_INFO, timeout=3)
						info = re.findall('Name:\s([a-zA-z0-9_-].*\.r[0-9][0-9]).*?Size:\s(\d+)', line, re.S|re.I)
						print info
						if info:
							unpacked_name = info[0][0].split('/')
							size = int(info[0][1]) / 1024 / 1024
							print unpacked_name
							print unpacked_name[-1]
							
							self.container.appClosed.append(boundFunction(self.extractDone2, unpacked_name[-1], rarunpackfile, rarname[0]))
							cmd = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unrar e -p%s -kb /media/hdd/movie/%s -o+ /media/hdd/movie/" % (rarpw, downloads_list[0][0])
							print "[Download] unrar cmd: %s" % cmd
							self.container.execute(cmd)
					
	def extractDone2(self, name, rarunpackfile, rarname, reval):
		print "reval:", reval
		print "name:", name
		self.container = eConsoleAppContainer()
		cmd = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unrar lt -pserienjunkies.org /media/hdd/movie/%s" % name
		print cmd
		p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
		line = p.stdout.read()
		info = re.findall('Name:\s([a-zA-z0-9_-].*\.avi|[a-zA-z0-9_-].*\.mkv|[a-zA-z0-9_-].*\.flv|[a-zA-z0-9_-].*\.mp4).*?Size:\s(\d+)', line, re.S|re.I)
		print info
		if info:
			unpacked_name = info[0][0].split('/')
			size = int(info[0][1]) / 1024 / 1024
			print unpacked_name
			print size
			print "[Download]", unpacked_name[-1], size
			self.container.appClosed.append(boundFunction(self.extractDone,unpacked_name[-1],rarname))
			self.container.dataAvail.append(self.testlog)	
			cmd = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unrar e -pserienjunkies.org -kb /media/hdd/movie/%s -o+ /media/hdd/movie/" % name
			print "[Download] unrar cmd: %s" % cmd
			self.container.execute(cmd)

			self.addunpack(name)
			self.removeRars(rarname)	
			
	
	def testlog(self, data):
		print data
		if re.match('.*?(CRC failed|CRC error|You need to start extraction from a previous volume to)', data, re.S|re.I):
			#Notifications.AddNotification(MessageBox, _("Unpacking Errorrrrssss.."), type=MessageBox.TYPE_INFO, timeout=3)
			message = self.session.open(MessageBox, _("Mediainfo: Unpacking Errorrrrssss.."), MessageBox.TYPE_INFO, timeout=3)

	def addunpack(self, rarfile):
		unpackingfile = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unpack"
		cmd = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unrar lt -pserienjunkies.org /media/hdd/movie/%s" % rarfile
		print cmd
		p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
		line = p.stdout.read()
		info = re.findall('Name:\s([a-zA-z0-9_-].*\.avi|[a-zA-z0-9_-].*\.mkv|[a-zA-z0-9_-].*\.flv|[a-zA-z0-9_-].*\.mp4).*?Size:\s(\d+)', line, re.S|re.I)
		print "info:", info
		if info:
			unpacked_name = info[0][0].split('/')
			size = int(info[0][1]) / 1024 / 1024			

			print "[Download]", unpacked_name[-1], size
				
		print "hier"
		if fileExists(unpackingfile):
			print "file vorhanden"
			print unpacked_name, size
			dlfile = open(unpackingfile, "a")
			dlfile.write('"%s" "%s"\n' % (unpacked_name[-1], size))
			dlfile.close()
		else:
			dlfile = open(unpackingfile, "w")
			dlfile.write('"%s" "%s"\n' % (unpacked_name[-1], size))
			dlfile.close()				

	def progressUpdate(self, data):				
		self.lastcmddata = data
		print data

	def progressUpdate2(self, rarfile):
		cmd = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unrar l -pserienjunkies.org /media/hdd/movie/%s" % rarfile
		p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
		for line in p.stdout.readlines():
			if not re.match('.*?(nfo|sample)', line, re.S|re.I) and re.match('.*?([a-zA-z0-9_-].*\.avi|[a-zA-z0-9_-].*\.mkv|[a-zA-z0-9_-].*\.flv|[a-zA-z0-9_-].*\.mp4)', line, re.S|re.I):
				info = re.findall('([a-zA-z0-9_-].*\.avi|[a-zA-z0-9_-].*\.mkv|[a-zA-z0-9_-].*\.flv|[a-zA-z0-9_-].*\.mp4).*?(.*?\d+)', line, re.S|re.I)
				(unpacked_name, size) = info[0]
				print size
				size = int(size) / 1024 / 1024
				print "[Download] unpacked SizEEEE.. %s MB" % str(size)
				filename = "/media/hdd/movie/"+unpacked_name
				print filename
				try:
					if fileExists(filename):
						print "[Download] real filesize"
						currentSizeMB = os.path.getsize(filename)/1024/1024
					else:
						print "file nicht vorhanden"
						currentSizeMB = 0
				except OSError:
					print "[Download] filesize error"
					currentSizeMB = 0
				print "[Download] unpacked filesize %s: %s MB" % (unpacked_name, str(currentSizeMB))
	
	def removeRars(self, checkname):
		print "[Download] remove %s-Rars from list" % checkname
		global joblist
		joblist_tmp = []
		for (name,job) in joblist:
			if not re.match('.*?'+checkname, name):
				joblist_tmp.append((name, job))

		joblist = joblist_tmp

		if fileExists(self.downloadsfile):
			dlfile = open(self.downloadsfile, "r")
			dlfile_tmp = open(self.downloadsfile+".tmp", "w")
			for rawData in dlfile.readlines():
				data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
				if data:
					(filename, storepath, url, totalMB, status, starttime) = data[0]
					if not re.match('.*?'+checkname, filename):
						dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, totalMB, status, starttime))

			dlfile_tmp.close()
			dlfile.close()
			shutil.move(self.downloadsfile+".tmp", self.downloadsfile)
			print "[Download] move:", self.downloadsfile+".tmp", self.downloadsfile
			self.startNext()

	def startNext(self):
		print "[Download] start next rar downloads.."
		dlfile = open(self.downloadsfile, "r")
		for rawData in dlfile.readlines():
			data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
			if data:
				(filename, storepath2, url2, totalMB, status2, starttime) = data[0]
				if status2 == "Wait":
					if re.match('.*?.part(\S+).rar', filename):
						print len(runslist), config.plugins.mediainfo.dllimit.value, status2
						if len(runslist) <= config.plugins.mediainfo.dllimit.value-1:
							runslist.append((filename))
							self.totalMB = 0
							self.checkname = filename
							print "2 RUUNNNNNNNNNNNNNNNNN", filename
							global joblist
							for (name,job) in joblist:
								if name == self.checkname:
									job.check(self.checkname)
						else:
							print "2 STOOOPPPPPPPPPPPPPPPP FULL"
		dlfile.close()
		
	def extractDone(self, name, rarname, reval):
		unpackingfile = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unpack"
		print "[Download] unpacking done for %s (%s)" % (name, rarname)
		self.container.kill()
		#Notifications.AddNotification(MessageBox, _("Upacking Done."), type=MessageBox.TYPE_INFO, timeout=10)
		message = self.session.open(MessageBox, ("Mediainfo: %s unpacked." % name), MessageBox.TYPE_INFO, timeout=3)
		
		# cleanup bad files
		filelist = glob.glob("%s*" % config.plugins.mediainfo.savetopath.value)
		for file in filelist:
			if file.endswith(('.nfo','.png','.jpg','.html')):
				print file
				os.remove(file)

		# del unpacked rar files
		if config.plugins.mediainfo.delunpack.value:
			filelist = glob.glob("%s%s.part*" % (config.plugins.mediainfo.savetopath.value, rarname))
			for file in filelist:
				print file
				os.remove(file)

#		dlfile = open(unpackingfile, "r")
#		dlfile_tmp = open(unpackingfile+".tmp", "w")
#		for rawData in dlfile.readlines():
#			data = re.findall('"(.*?)" "(.*?)"', rawData, re.S)
#			if data:
#				(filename, totalMB) = data[0]
#				if filename != rarfile:
#					dlfile_tmp.write('"%s" "%s"\n' % (filename, totalMB))
#		dlfile_tmp.close()
#		dlfile.close()
#		shutil.move(unpackingfile+".tmp", unpackingfile)

	def http_failed(self, failure_instance=None, error_message=""):
		print "[Download] http_failed", self.checkname
		
		global runslist
		checkfilename = ((self.checkname))
		if checkfilename in runslist:
			runslist.remove((self.checkname))
			print "[Download] file removed from runslist: %s" % self.checkname

		if error_message == "" and failure_instance is not None:
			error_message = failure_instance.getErrorMessage()
			print "[Download] http_failed " + error_message
	
			if error_message != "200 OK":
				print "[Download] error:", self.checkname
				dlfile = open(self.downloadsfile, "r")
				dlfile_tmp = open(self.downloadsfile+".tmp", "w")
				for rawData in dlfile.readlines():
					data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
					if data:
						(filename, storepath, url, totalMB, status, starttime) = data[0]
						print self.checkname, filename
						if filename == self.checkname:
							print "replace it..."
							dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, totalMB, "Error", starttime))
						else:
							dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, totalMB, status, starttime))
				dlfile_tmp.close()
				dlfile.close()
				shutil.move(self.downloadsfile+".tmp", self.downloadsfile)
				print "[Download] move:", self.downloadsfile+".tmp", self.downloadsfile

	def dataError(self, error):
		print error
		
class mediaInfoSetup(ConfigListScreen, Screen):
	skin = """
		<screen name="MediaInfo Setup" position="center,center" size="1280,720" backgroundColor="#00060606" title="MediaInfo v1.2" flags="wfNoBorder">
			<ePixmap position="0,0" size="1280,720" zPosition="-1"/>
			<widget source="global.CurrentTime" render="Label" position="50,20" size="300,28" font="Regular; 25" halign="left" backgroundColor="#26181d20" transparent="1" foregroundColor="#00999999">
			  <convert type="ClockToText">Format:%A, %d.%m.%Y</convert>
			</widget>
			<widget source="global.CurrentTime" render="Label" position="50,50" size="100,28" font="Regular;25" halign="left" backgroundColor="#26181d20" transparent="1" foregroundColor="#00999999">
			  <convert type="ClockToText">Default</convert>
			</widget>
			<widget source="session.VideoPicture" render="Pig" position="930,10" size="328,186" zPosition="3" backgroundColor="transparent" />
			<eLabel position="930,10" size="330,188" backgroundColor="#00ffffff" zPosition="0" name="Videoback" foregroundColor="#00ffffff" />
			<widget name="pname" position="50,105" size="1025,30" zPosition="0" font="Regular;26" transparent="1" foregroundColor="white" />
			<widget name="pinfo" position="50,135" size="1025,30" zPosition="0" font="Regular;26" transparent="1" foregroundColor="white" />
			<widget name="head" position="0,200" size="1280,25" backgroundColor="#00aaaaaa" zPosition="5" foregroundColor="#00000000" font="Regular;23" halign="center"/>
			<widget name="config" position="0,225" size="1280,325" backgroundColor="#00101214" scrollbarMode="showOnDemand" transparent="0" selectionPixmap="/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/buttons/sel.png"/>
			<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/buttons/key_red.png" position="20,690" size="30,30" alphatest="blend" />
			<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/buttons/key_green.png" position="240,690" size="30,30" alphatest="blend" />
			<eLabel text="Abbrechen" position="60,690" size="180,26" zPosition="1" font="Regular;20" halign="left" foregroundColor="grey" backgroundColor="black" transparent="1" />
			<eLabel text="Speichern" position="280,690" size="180,26" zPosition="1" font="Regular;19" halign="left" foregroundColor="grey" backgroundColor="black" transparent="1" />
			</screen>"""

	def __init__(self, session):
		Screen.__init__(self, session)
		self.session = session
		
		self.configlist = []
		ConfigListScreen.__init__(self, self.configlist)
		self.configlist.append(getConfigListEntry("Zeige Nachricht bei fertigen Download:", config.plugins.mediainfo.donemsg))
		self.configlist.append(getConfigListEntry("Premiumize:", config.plugins.mediainfo.premiumize))
		self.configlist.append(getConfigListEntry("Premiumize User:", config.plugins.mediainfo.premiumize_user))
		self.configlist.append(getConfigListEntry("Premiumize Pass:", config.plugins.mediainfo.premiumize_pass))
		self.configlist.append(getConfigListEntry("Max. parallel Downloads:", config.plugins.mediainfo.dllimit))
		self.configlist.append(getConfigListEntry("Buffer Size:", config.plugins.mediainfo.buffersize))
		self.configlist.append(getConfigListEntry("Speicher Downloads nach:", config.plugins.mediainfo.savetopath))
		
		self["config"].setList(self.configlist)
		self["pname"] = Label("")
		self["pinfo"] = Label("")
		self["head"] = Label("Einstellungen:")
		
		self["actions"]  = ActionMap(["OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions"], {
			"green" : self.keySave,
			"red": self.keyCancel,
			"cancel": self.keySave
		}, -1)
		
	def keySave(self):
		for x in self["config"].list:
			x[1].save()
		configfile.save()
		self.close(True)
		
	def keyCancel(self):
		for x in self["config"].list:
			x[1].save()
		configfile.save()
		self.close(False)
		
def dlListEntry(entry):
	if entry[6] == "":
		dlspeed = ""
	else:
		dlspeed = " @  %s" % str(entry[6])
		
	currentMB = "%smb / %smb %s" % (str(entry[3]), str(entry[4]), dlspeed)
		
	if int(entry[4]) == 0:
		test = 100
	else:
		test = entry[4]
		
	if int(entry[3]) > 0:
		currentProgress = int(float(100) / float(int(test)) * int(entry[3]))
	else:
		currentProgress = 0
		
	proanzeige = str(currentProgress)+"%"	
	color2 = 0x00ffffff #Weiss

	return [entry,
		(eListboxPythonMultiContent.TYPE_TEXT, 50, 0, 500, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, entry[0], color2, color2, None, None),
		(eListboxPythonMultiContent.TYPE_TEXT, 560, 0, 360, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, currentMB, color2, color2 , None, None),
		(eListboxPythonMultiContent.TYPE_PROGRESS, 920, 0, 120, 22, int(currentProgress), None, None, color2, None),
		(eListboxPythonMultiContent.TYPE_TEXT, 1050, 0, 70, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, proanzeige, color2, color2 , None, None),
		(eListboxPythonMultiContent.TYPE_TEXT, 1140, 0, 130, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, entry[5], color2, color2, None, None)
		]
		
def unpackListEntry(entry):
	currentMB = "%smb / %smb" % (str(entry[1]), str(entry[2]))
	if int(entry[1]) > 0:
		try:
			currentProgress = int(float(100) / float(int(entry[2])) * int(entry[1]))
		except:
			currentProgress = 0
	else:
		currentProgress = 0

	color2 = 0x00ffffff #Weiss
	
	return [entry,
		(eListboxPythonMultiContent.TYPE_TEXT, 50, 0, 500, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, entry[0], color2, color2, None, None),
		(eListboxPythonMultiContent.TYPE_TEXT, 560, 0, 380, 25, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, currentMB, color2, color2 , None, None),
		(eListboxPythonMultiContent.TYPE_PROGRESS, 940, 0, 180, 22, int(currentProgress), None, None, color2, None),
		]
		
class mediaInfo(ConfigListScreen, Screen):
	skin = """
		<screen name="MediaInfo" position="center,center" size="1280,720" backgroundColor="#00060606" title="MediaInfo v1.2" flags="wfNoBorder">
			<ePixmap position="0,0" size="1280,720" zPosition="-1"/>
			<widget source="global.CurrentTime" render="Label" position="50,20" size="300,28" font="Regular; 25" halign="left" backgroundColor="#26181d20" transparent="1" foregroundColor="#00999999">
			  <convert type="ClockToText">Format:%A, %d.%m.%Y</convert>
			</widget>
			<widget source="global.CurrentTime" render="Label" position="50,50" size="100,28" font="Regular;25" halign="left" backgroundColor="#26181d20" transparent="1" foregroundColor="#00999999">
			  <convert type="ClockToText">Default</convert>
			</widget>
			<widget source="session.VideoPicture" render="Pig" position="930,10" size="328,186" zPosition="3" backgroundColor="transparent" />
			<eLabel position="930,10" size="330,188" backgroundColor="#00ffffff" zPosition="0" name="Videoback" foregroundColor="#00ffffff" />
			<widget name="pname" position="50,105" size="1025,30" zPosition="0" font="Regular;26" transparent="1" foregroundColor="white" />
			<widget name="pinfo" position="50,135" size="1025,30" zPosition="0" font="Regular;26" transparent="1" foregroundColor="white" />
			<widget name="head" position="0,200" size="1280,25" backgroundColor="#00aaaaaa" zPosition="5" foregroundColor="#00000000" font="Regular;23" halign="center"/>
			<widget name="dllist" position="0,225" size="1280,325" backgroundColor="#00101214" scrollbarMode="showOnDemand" transparent="0" selectionPixmap="/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/buttons/sel.png"/>
			<widget name="head2" position="0,550" size="1280,25" backgroundColor="#00aaaaaa" zPosition="5" foregroundColor="#00000000" font="Regular;23" halign="center"/>
			<widget name="unpacklist" position="0,575" size="1280,100" backgroundColor="#00101214" scrollbarMode="showOnDemand" transparent="0" selectionPixmap="/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/buttons/sel.png"/>
			<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/buttons/key_red.png" position="20,690" size="30,30" alphatest="blend" />
			<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/buttons/key_green.png" position="240,690" size="30,30" alphatest="blend" />
			<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/buttons/key_yellow.png" position="460,690" size="30,30" alphatest="blend" />
			<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/buttons/key_blue.png" position="700,690" size="30,30" alphatest="blend" />
			<eLabel text="Loeschen" position="60,690" size="180,26" zPosition="1" font="Regular;20" halign="left" foregroundColor="grey" backgroundColor="black" transparent="1" />
			<eLabel text="AddDownload" position="280,690" size="180,26" zPosition="1" font="Regular;19" halign="left" foregroundColor="grey" backgroundColor="black" transparent="1" />
			<eLabel text="Start/Stop Download" position="500,690" size="200,26" zPosition="1" font="Regular;19" halign="left" foregroundColor="grey" backgroundColor="black" transparent="1" />
			<eLabel text="Einstellung" position="740,690" size="160,26" zPosition="1" font="Regular;20" halign="left" foregroundColor="grey" backgroundColor="black" transparent="1" />
			<widget name="pstatus" position="900,690" size="350,26" zPosition="1" font="Regular;20" halign="left" foregroundColor="grey" backgroundColor="black" transparent="1" />
			</screen>"""

	def __init__(self, session, livestreaming):
		Screen.__init__(self, session)
		self.session = session
		self.livestreaming = livestreaming

		self["pname"] = Label("")
		self["pinfo"] = Label("")
		self["pstatus"] = Label("")
		cinfo = "Downloads: 0 / %s - Wait: 0 - Done: 0 - Error: 0" % str(config.plugins.mediainfo.dllimit.value)
		self['head'] = Label(cinfo)
		self['head2'] = Label("Current Unpacking:")

		self.dllist = []
		self.chooseMenuList = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		self.chooseMenuList.l.setFont(0, gFont('Regular', 24))
		self.chooseMenuList.l.setItemHeight(25)
		self['dllist'] = self.chooseMenuList
		
		self.chooseMenuList2 = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		self.chooseMenuList2.l.setFont(0, gFont('Regular', 24))
		self.chooseMenuList2.l.setItemHeight(25)
		self['unpacklist'] = self.chooseMenuList2

		self.downloadsfile = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/downloads"
		self.refreshTimer = eTimer()
		self.refreshTimer.callback.append(self.refresh)
		self.refreshTimer.start(2000)
		
		self.refreshTimer2 = eTimer()
		self.refreshTimer2.callback.append(self.refresh2)
		self.refreshTimer2.start(3000)
		
		self.updateTimer = eTimer()
		self.updateTimer.callback.append(self.get_info)

		self.currentList = "dllist"
		self["unpacklist"].selectionEnabled(0)
		self["dllist"].selectionEnabled(1)
		
		self.joblist = []
		self.onClose.append(self.__onClose)
		
		if self.livestreaming:
			self.onLayoutFinish.append(self.get_info)
			self.onLayoutFinish.append(self.check_status)
		else:
			self.onLayoutFinish.append(self.check_status)

		self["actions"] = ActionMap(["WizardActions"],
		{
			"back": self.exit,
		}, -1)
		
		self["actions"]  = ActionMap(["OkCancelActions", "ShortcutActions", "EPGSelectActions", "WizardActions", "ColorActions", "NumberActions", "MenuActions", "MoviePlayerActions", "InfobarSeekActions"], {
			"ok" : self.exit,
			"info" : self.exit,
			"cancel" : self.exit,
			"red" : self.dlremove,
			"green" : self.dlrun,
			"yellow" : self.dlcheck,
			"blue" : self.dlmenu,
			"nextBouquet" : self.keySwitchList,
			"prevBouquet" : self.keySwitchList,
			"up"    : self.keyUp,
			"down"  : self.keyDown,
			"left"  : self.keyLeft,
			"right" : self.keyRight
		}, -1)

	def keyLeft(self):
		self[self.currentList].pageUp()

	def keyRight(self):
		self[self.currentList].pageDown()

	def keyUp(self):
		self[self.currentList].up()
		
	def keyDown(self):
		self[self.currentList].down()
		
	def keySwitchList(self):
		if self.currentList == "dllist":
			self["dllist"].selectionEnabled(0)
			self["unpacklist"].selectionEnabled(1)
			self.currentList = "unpacklist"
		else:
			self["unpacklist"].selectionEnabled(0)
			self["dllist"].selectionEnabled(1)
			self.currentList = "dllist"
			
		print "[Download] switch to: %s" % self.currentList

	def startRefreshTimer2(self):
		print "Starte Unpackkkkkkkkkkkkkkkkkkkk refresher..."
		
	def check_status(self):
		if config.plugins.mediainfo.premiumize.value:
			api_url = "https://api.premiumize.me/pm-api/v1.php?method=accountstatus&params[login]=%s&params[pass]=%s" % (config.plugins.mediainfo.premiumize_user.value, config.plugins.mediainfo.premiumize_pass.value)
			getPage(api_url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.get_status)
		else:
			self["pstatus"].setText("Premiumize: Nicht Aktiviert")
		
	def get_status(self, data):
		login = re.findall('"statusmessage":"(.*?)"', data)
		if login:
			global pstatus
			if re.match('.*?OK', login[0]):
				#print "[Download] logged in."
				pstatus = True
				status = re.findall('"type":"(.*?)"\,"expires":(.*?),"', data)
				#print status
				(type, expires) = status[0]
				zeit = datetime.datetime.fromtimestamp(int(expires)).strftime('%d-%m-%Y %H:%M:%S')
				status = "Prmiumize: %s bis %s" % (type, zeit)
				#print status
				self["pstatus"].setText(status)
			else:
				self["pstatus"].setText("Premiumize: Login Error")
				print "[Download] login failed."
				config.plugins.mediainfo.premiumize.value = False
				config.plugins.mediainfo.premiumize.save()
				configfile.save()
				pstatus = False

	def starten(self, url, filename):
		if config.plugins.mediainfo.premiumize.value:
			#print "[Download] added: %s - %s" % (filename, url)
			if re.search('ul.to', url):
				if re.search('ul.to/.*?/', url, re.S|re.I):
					id = re.findall('ul.to/(.*?)/', url, re.S|re.I)

				elif re.search('ul.to/.*?', url, re.S|re.I):
					id = re.findall('ul.to/(.*?)$', url, re.S|re.I)

				print id
				uurl = 'http://uploaded.net/file/%s/status' % id[0]
				print uurl
				getPage(uurl).addCallback(self.dstarten, url).addErrback(self.dataError)

			elif re.search('uploaded.(net|to)', url, re.S|re.I):
				if re.search('uploaded.(net|to)/file/.*?/', url, re.S|re.I):
					id = re.findall('uploaded.*?/file/(.*?)/', url, re.S|re.I)

				elif re.search('uploaded.(net|to)/file/.*?', url, re.S|re.I):
					id = re.findall('uploaded.*?/file/(.*?)$', url, re.S|re.I)

				print id
				uurl = 'http://uploaded.net/file/%s/status' % id[0]
				print uurl
				getPage(uurl).addCallback(self.dstarten, url).addErrback(self.dataError)
				
			elif re.search('clz.to', url, re.S|re.I):
				if re.search('clz.to/.*?/', url, re.S|re.I):
					id = re.findall('clz.to/(.*?)/', url, re.S|re.I)

				elif re.search('clz.to/.*?', url, re.S|re.I):
					id = re.findall('clz.to/(.*?)$', url, re.S|re.I)
			
				print id
				curl = 'http://cloudzer.net/file/%s/status' % id[0]
				print curl
				getPage(curl).addCallback(self.dstarten, url).addErrback(self.dataError)
				
			elif re.search('cloudzer.net', url, re.S|re.I):
				if re.search('cloudzer.net/file/.*?/', url, re.S|re.I):
					id = re.findall('cloudzer.net/file/(.*?)/', url, re.S|re.I)

				elif re.search('cloudzer.net/file/.*?', url, re.S|re.I):
					id = re.findall('cloudzer.net/file/(.*?)$', url, re.S|re.I)
			
				print id
				curl = 'http://cloudzer.net/file/%s/status' % id[0]
				print curl
				getPage(curl).addCallback(self.dstarten, url).addErrback(self.dataError)
		else:
			print "[Download] no premiumize.me aktiviert."
			
	def dstarten(self, data, url):
		filename = re.findall('(.*?.rar)', data, re.S|re.I)
		if filename:
			self.currentDownload = dlm(self.session, filename[0], url)
			joblist.append((filename[0], self.currentDownload))
			self.currentDownload.add(filename[0])
	
	def dataError(self, error):
		print error

	def dlrun(self):
		service = self.session.nav.getCurrentService()
		filename = service.info().getName()
		url = self.session.nav.getCurrentlyPlayingServiceReference().getPath()
		filename = ''.join(re.split(r'[.;:!&?,]', filename))
		filetype = re.findall('(\.avi|\.mp4|\.ts|\.mp3|\.mpg|\.mpeg)', url, re.I)
		if filetype:
			filetype = filetype[0]
		else:
			filetype = ".flv"
		filename = "%s%s" % (filename.replace(' ','_'), filetype)
		
		if not any(filename in job for job in joblist):
			if re.match('.*?http', url, re.S):
				try:
					req = urllib2.Request(url)
					res = urllib2.urlopen(req)
					url = res.geturl()
					print "[Download] added: %s - %s" % (filename, url)
					self.currentDownload = dlm(self.session, filename, url)
					joblist.append((filename, self.currentDownload))
					self.currentDownload.run(filename)
				except urllib2.HTTPError, error:
					print error
					message = self.session.open(MessageBox, ("Fehler: %s" % error), MessageBox.TYPE_INFO, timeout=3)
				except urllib2.URLError, error:
					print error.reason
					message = self.session.open(MessageBox, ("Fehler: %s" % error.reason), MessageBox.TYPE_INFO, timeout=3)
			else:
				message = self.session.open(MessageBox, ("No rtmp download support, only http protocl."), MessageBox.TYPE_INFO, timeout=3)
		else:
			print "[Download] dupe: %s" % filename
		
	def dlcheck(self):
		exist = self['dllist'].getCurrent()
		if exist == None:
			return
			
		if self.currentList == "dllist":
			checkname = self['dllist'].getCurrent()[0][0]
			url = self['dllist'].getCurrent()[0][2]
			status = self['dllist'].getCurrent()[0][5]
			print "[Download] check:", checkname, url, status

			if status == "Download":
				global joblist
				for (name,job) in joblist:
					if name == checkname:
						job.stop(checkname)

			elif status == "Stop":
				global joblist
				for (name,job) in joblist:
					if name == checkname:
						job.check(checkname)

			elif status == "Wait":
				global joblist
				for (name,job) in joblist:
					if name == checkname:
						job.check(checkname)

			elif status == "Error":
				global joblist
				for (name,job) in joblist:
					if name == checkname:
						job.check(checkname)

	def dlremove(self):
		print "[Download] currentlist: %s" % self.currentList

		if self.currentList == "unpacklist":
			exist = self['unpacklist'].getCurrent()
			if exist == None:
				return
				
			checkname = self['unpacklist'].getCurrent()[0][0]
			print "[Download] remove from unpackinglist: %s" % checkname
		
			unpackingfile = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unpack"
			dlfile = open(unpackingfile, "r")
			dlfile_tmp = open(unpackingfile+".tmp", "w")
			for rawData in dlfile.readlines():
				data = re.findall('"(.*?)" "(.*?)"', rawData, re.S)
				if data:
					(filename, totalMB) = data[0]
					if filename != checkname:
						dlfile_tmp.write('"%s" "%s"\n' % (filename, totalMB))
			dlfile_tmp.close()
			dlfile.close()
			shutil.move(unpackingfile+".tmp", unpackingfile)		

		else:
			exist = self['dllist'].getCurrent()
			if exist == None:
				return
				
			checkname = self['dllist'].getCurrent()[0][0]
			status = self['dllist'].getCurrent()[0][5]
			print "[Download] remove: %s" % checkname
			global runslist
			global joblist
			
			if re.match('.*?.part(\S+).rar', checkname, re.I):
				removejobname = ""
				rarname =  re.compile(".part", re.IGNORECASE).split(checkname)
				print rarname
				#downloads_list = "downloads_list"+rarfile
				downloads_list = []
				if fileExists(self.downloadsfile):
					dlfile = open(self.downloadsfile, "r")
					dlfile_tmp = open(self.downloadsfile+".tmp", "w")
					for rawData in dlfile.readlines():
						data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
						if data:
							(filename, storepath, url, totalMB, status, starttime) = data[0]
							if re.match('.*?'+rarname[0].replace('+',''), filename.replace('+','')):
								removejobname = filename
								checkfilename = (filename)
								if checkfilename in runslist:
									runslist.remove((filename))
								#downloads_list.append((filename, status))
							else:
								dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, totalMB, status, starttime))
					dlfile_tmp.close()
					dlfile.close()
					shutil.move(self.downloadsfile+".tmp", self.downloadsfile)
					print "[Download] move:", self.downloadsfile+".tmp", self.downloadsfile

				if removejobname:
					joblist_tmp = []
					for (name,job) in joblist:
						print name,job
						if name != removejobname:
							joblist_tmp.append((name, job))
					joblist = joblist_tmp

			else:
				if status == "Download":
					
					for (name,job) in joblist:
						if name == checkname:
							job.stop(checkname)
							
				joblist_tmp = []
				for (name,job) in joblist:
					print name,job
					if name != checkname:
						joblist_tmp.append((name, job))

				joblist = joblist_tmp
				print "---------------------------------------------------"
				
				for (name,job) in joblist:
					print name,job

				if fileExists(self.downloadsfile):
					dlfile = open(self.downloadsfile, "r")
					dlfile_tmp = open(self.downloadsfile+".tmp", "w")
					for rawData in dlfile.readlines():
						data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
						if data:
							(filename, storepath, url, totalMB, status, starttime) = data[0]
							if filename != checkname:
								dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, totalMB, status, starttime))

					dlfile_tmp.close()
					dlfile.close()
					shutil.move(self.downloadsfile+".tmp", self.downloadsfile)
					print "[Download] move:", self.downloadsfile+".tmp", self.downloadsfile

	def refresh(self):
		if fileExists(self.downloadsfile):
			dlfile = open(self.downloadsfile, "r")
			self.dllist = []
			self.waitlist = []
			self.donelist = []
			self.errorlist = []
			cDownloads = 0
			cWait = 0
			cDone = 0
			cError = 0
			global runslist
			cRunslist = len(runslist)
			#runslist_tmp = []
			for rawData in dlfile.readlines():
				data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
				if data:
					(filename, storepath, url, totalMB, status, starttime) = data[0]
					try:
						currentSizeMB = os.path.getsize(storepath)/1024/1024
					except OSError:
						currentSizeMB = 0

					if status == "Download":
						endtime = int(time.time())
						runtime = endtime - int(starttime)
						if runtime == 0:
							#print "[Download] set runtime: 1sec."
							runtime = 1
						if currentSizeMB == 0:
							#print "[Download] set currentSize: 1 mb."
							currentSizeMB = 1
							
						dlspeed = (currentSizeMB * 1024) / runtime
						
						resttime = (((int(totalMB) - currentSizeMB) * 1024) / (currentSizeMB * 1024)) * runtime
						if dlspeed > 1024:
							dlspeed = "%.2f mb/s" % (float(dlspeed) / 1024)
						else:
							dlspeed = "%s kb/s" % dlspeed
							
						#print "[Download] dl-speed: %s - finish in: %s sec." % (dlspeed, str(resttime))	
					else:
						dlspeed = ""
						resttime = ""

					if status == "Download":
					#	checky = ((filename))
					#	if checky in runslist:
					#		runslist_tmp.append((filename))
					#	else:
					#		print "[Download] NOT IN RUNSLIST.......rEMOVe..... %s" % filename
							
						cDownloads += 1
						self.dllist.append((filename, storepath, url, str(currentSizeMB), str(totalMB), status, str(dlspeed), str(resttime)))
					elif status == "Wait":
						cWait += 1
						self.waitlist.append((filename, storepath, url, str(currentSizeMB), str(totalMB), status, str(dlspeed), str(resttime)))
					elif status == "Done":
						cDone += 1
						self.donelist.append((filename, storepath, url, str(currentSizeMB), str(totalMB), status, str(dlspeed), str(resttime)))
					elif status == "Error":
						cError += 1
						self.errorlist.append((filename, storepath, url, str(currentSizeMB), str(totalMB), status, str(dlspeed), str(resttime)))
			dlfile.close()
			cinfo = "Downloads: %s / %s - Wait: %s - Done: %s - Error: %s - Runslist: %s" % (str(cDownloads), str(config.plugins.mediainfo.dllimit.value), str(cWait), str(cDone), str(cError), str(cRunslist))
			self["head"].setText(cinfo)
			#runslist = runslist_tmp
			self.dllist_new = self.dllist + self.waitlist + self.donelist + self.errorlist
			self.chooseMenuList.setList(map(dlListEntry, self.dllist_new))

	def refresh2(self):
		unpackingfile = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/unpack"
		if fileExists(unpackingfile):
			self.unpacklist = []
			dlfile = open(unpackingfile, "r")
			dlfile_tmp = open(unpackingfile+".tmp", "w")
			for rawData in dlfile.readlines():
				data = re.findall('"(.*?)" "(.*?)"', rawData, re.S)
				if data:
					(filename, totalMB) = data[0]
					afilename = "/media/hdd/movie/"+filename
					try:
						currentSizeMB = os.path.getsize(afilename)/1024/1024
					except OSError:
						currentSizeMB = 0

					if int(currentSizeMB) != int(totalMB):
						self.unpacklist.append((filename, currentSizeMB, totalMB))
						dlfile_tmp.write('"%s" "%s"\n' % (filename, totalMB))

			dlfile_tmp.close()
			dlfile.close()
			shutil.move(unpackingfile+".tmp", unpackingfile)
			self.chooseMenuList2.setList(map(unpackListEntry, self.unpacklist))
						
	def get_info(self):
		#self.check_status()
		self.updateTimer.stop()
		service = self.session.nav.getCurrentService()
		#service.streamed().setBufferSize(config.plugins.mediainfo.buffersize.value)
		service.streamed().setBufferSize(long(int(config.plugins.mediainfo.buffersize.value)) * 1024 * 1024)
		bufferInfo = service.streamed().getBufferCharge()
		pname_text = service.info().getName()
		url_text = self.session.nav.getCurrentlyPlayingServiceReference().getPath()
	
		if bufferInfo != None: 
			if bufferInfo[2] != 0:
				self.bufferSeconds = bufferInfo[4] / bufferInfo[2] #buffer size / avgOutRate
			else:
				self.bufferSeconds = 0
				
			self.bufferPercent = bufferInfo[0]
			self.bufferSecondsLeft = self.bufferSeconds * self.bufferPercent / 100
			self["pname"].setText("%s" % str(pname_text))
			self["pinfo"].setText("Stream %s - Bitrate: %s - Buffer: %s filled %s (%s sec.)" % (self.formatKB(bufferInfo[1]), self.formatKBits(bufferInfo[2]), self.bufferPercent, self.formatKB(bufferInfo[4]), self.bufferSecondsLeft))
			self.updateTimer.start(2000)

	def dlmenu(self):
		self.session.openWithCallback(self.setupCallback, mediaInfoSetup)
	
	def setupCallback(self, callback):
		self.check_status()

	def exit(self):
		already_open = False
		self.close()
		
	def __onClose(self):
		print "[Download] windows closed"
		self.updateTimer.stop()
		self.refreshTimer.stop()
		self.refreshTimer2.stop()
		
	def formatKBits(self, value, ending="Bit/s", roundNumbers=2):
		bits = value * 8
		if bits > (1024*1024):
			return str(    round(float(bits)/float(1024*1024),roundNumbers)  )+" M"+ending
		if bits > 1024:
			return str(    round(float(bits)/float(1024),roundNumbers)       )+" K"+ending
		else:
			return str(bits)+" "+ending
		
	def formatKB(self, value, ending="B", roundNumbers=2):
		byte = value
		if byte > (1024*1024):
			return str(    round(float(byte)/float(1024*1024),roundNumbers) )+" M"+ending
		if byte > 1024:
			return str(    round(float(byte)/float(1024),roundNumbers)      )+" K"+ending
		else:
			return str(byte)+" "+ending
		
def openMoviePlayerEventView(self):
	already_open = False
	if True and not already_open:
		already_open = True
		service = self.session.nav.getCurrentService()
		filename = service.info().getName()
		url = self.session.nav.getCurrentlyPlayingServiceReference().getPath()
		if re.match('.*?http://', url, re.S):
			self.session.open(mediaInfo, True)
		else:
			self.session.open(mediaInfo, False)
	else:
		MoviePlayer.originalOpenEventView(self)
		
MoviePlayer.openEventView = openMoviePlayerEventView

def autostart(session, **kwargs):
	#if reason == 0 and kwargs.has_key("session"):
	#session = kwargs["session"]

	downloadsfile = "/usr/lib/enigma2/python/Plugins/Extensions/mediainfo/downloads"
	if fileExists(downloadsfile):
		dlfile = open(downloadsfile, "r")
		dlfile_tmp = open(downloadsfile+".tmp", "w")
		for rawData in dlfile.readlines():
			data = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', rawData, re.S)
			if data:
				(filename, storepath, url, totalMB, status, starttime) = data[0]
				try:
					currentSizeMB = os.path.getsize(storepath)/1024/1024
				except OSError:
					currentSizeMB = 0
				
				if int(currentSizeMB) == int(totalMB):
					dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, totalMB, "Done", starttime))
					print "[Download] mark as: Done - %s" % storepath
				else:
					dlfile_tmp.write('"%s" "%s" "%s" "%s" "%s" "%s"\n' % (filename, storepath, url, totalMB, "Wait", starttime))
					print "[Download] mark as: Wait - %s" % storepath
					
				currentDownload = dlm(session, filename.replace(' ','_'), url)
				global joblist
				joblist.append((filename.replace(' ','_'), currentDownload))
		dlfile.close()
		dlfile_tmp.close()
		print "[Download] move:", downloadsfile+".tmp", downloadsfile
		shutil.move(downloadsfile+".tmp", downloadsfile)
		
		if config.plugins.mediainfo.premiumize.value:
			print "[Download] check status.."
			api_url = "https://api.premiumize.me/pm-api/v1.php?method=accountstatus&params[login]=%s&params[pass]=%s" % (config.plugins.mediainfo.premiumize_user.value, config.plugins.mediainfo.premiumize_pass.value)
			getPage(api_url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(get_status2)
		
def get_status2(data):
	login = re.findall('"statusmessage":"(.*?)"', data)
	if login:
		global pstatus
		if re.match('.*?OK', login[0]):
			print "[Download] logged in."
			pstatus = True
		else:
			print "[Download] login failed."
			pstatus = False

def main(session,**kwargs):
	session.open(mediaInfo, False)
	
def Plugins(**kwargs):
	return [PluginDescriptor(name="MediaInfo", description="StreamDownloads", where = [PluginDescriptor.WHERE_PLUGINMENU], fnc=main),
			PluginDescriptor(where=[PluginDescriptor.WHERE_SESSIONSTART], fnc=autostart)]
			#PluginDescriptor(where = PluginDescriptor.WHERE_AUTOSTART, fnc = autostart)]
			#PluginDescriptor(where=[PluginDescriptor.WHERE_AUTOSTART], fnc=autostart)]